#include <ZumoMotors.h>  //ZUMO 
#include <EEPROM.h>
#include <LSM303.h>// 

#define left_sharp_pin A3
#define forward_sharp_pin A4
#define right_sharp_pin A0
#define back_sharp_pin A1
#define BASE_SPEED 150
#define MAX_SPEED 250
#define MIN_SPEED 50
#define turn 370
#define turnturn 710
int left_distance;
int right_distance;
int forward_distance;
int back_distance;
int start_back_dist; //       
float Kp = 1;
byte Kd = 70;
float Kk = 0.00022;
int error = 0;
int lasterror = 0;
byte wall_mode = 0;//0 -  , 1 - , 2 - , 3 - 
short old_wall_mode = -1;
#define wallexist 200 //       
#define  half_cell  95 //  -      
#define  step_time 780 //    30 
long stop_step; //  
int r_direction = 0;
bool localized = false;//
byte step_count = 0;
byte shortstepscount;//    
bool mode = false;//false -    , true -   

//    
//   running_min.x   1000, running_min.y   1002, running_max.x   1004, running_max   1006
LSM303 compass;

int running_min_x = 0;
int running_min_y = 0;
int running_max_x = 0;
int running_max_y = 0;

//   
typedef struct
{
	bool left;
	bool right;
	bool forw;
	bool back;
	bool vizited;
} TCell; //Declare and define struct TMyStruct

typedef struct
{
	byte x;
	byte y;
} TPoint;

TPoint startPoint;//set on start
TPoint currentPoint;//set after every step
TPoint finishPoint; //set on finish color
TCell normallab[5][8];//normal labirint
TPoint shortpath[40];//list of points on short path
int matrix[5][8];
byte find_lab[5][5];//  ,      

byte labirint[] {14, 8, 10, 8, 11, 12, 3, 13, 5, 13, 5, 12, 0, 3, 5, 7, 5, 7, 12, 3, 14, 2, 10, 2, 11, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15};
ZumoMotors motors;

void setup() {
	Serial.begin(9600);
	pinMode(left_sharp_pin, INPUT); //  
	pinMode(forward_sharp_pin, INPUT);
	pinMode(right_sharp_pin, INPUT);
	pinMode(back_sharp_pin, INPUT);
	delay(1000);
	//  get_distance();
	mode = forward_distance < 100;
	delay(3000);
	Serial.println("start");
	motors.flipLeftMotor(true);
	motors.flipRightMotor(true);
	startinit();
}

void initcompass()
{
	running_min_x = EEPROMReadInt(1000);
	running_min_y = EEPROMReadInt(1002);
	running_max_x = EEPROMReadInt(1004);
	running_max_y = EEPROMReadInt(1006);
	compass.m_max.x = running_max_x;
	compass.m_max.y = running_max_y;
	compass.m_min.x = running_min_x;
	compass.m_min.y = running_min_y;
}

void loop() {

	ShortGo(0, 0, 2, 3);
	ShortGo(2, 3, 0, 4);
	ShortGo(0, 4, 4, 2);
	ShortGo(4, 2, 4, 4);
}

void show_sensors()
{
	Serial.print(left_distance);
	Serial.print(" | ");
	Serial.print(forward_distance);
	Serial.print(" | ");
	Serial.print(right_distance);
	Serial.print(" | ");
	Serial.print(back_distance);
	Serial.println("");
}

//   3 
void get_distance()
{
	int sharp = analogRead(left_sharp_pin);
	left_distance = min(20760 / (sharp - 11), 300);
	if (left_distance < 0) left_distance = 300;
	sharp = analogRead(forward_sharp_pin);
	forward_distance = min(20760 / (sharp - 11), 300);
	if (forward_distance < 0) forward_distance = 300;
	sharp = analogRead(right_sharp_pin);
	right_distance = min(20760 / (sharp - 11), 300) - 10;//+10 ..       1     
	if (right_distance < 0 || right_distance >300) right_distance = 300;

	sharp = analogRead(back_sharp_pin);
	back_distance = min(20760 / (sharp - 11), 300);//+10 ..       1     
	if (back_distance < 0 || back_distance >300) back_distance = 300;
	// back_distance = min(48000/(sharp-20), 800); 
	// if (back_distance < 0) back_distance = 800;

}

//  
void set_pid()
{
	int speedDifference = 0;
	get_distance();//    
	getwallmode();//   wall_mode
	switch (wall_mode)
	{
	case 3:
		error = left_distance - right_distance;
		speedDifference = Kp * error + Kd * (error - lasterror) + Kk*error*error*error;
		break;

	case 2:
		error = (right_distance - half_cell)*-2;
		speedDifference = Kp * error + Kd * (error - lasterror) + Kk*error*error*error;
		break;

	case 1:
		error = (left_distance - half_cell) * 2;
		speedDifference = Kp * error + Kd * (error - lasterror) + Kk*error*error*error;
		break;

	case 0:
		speedDifference = 0;
		break;

	}//end of switch (wall_mode)

	lasterror = error;
	int RightSpeed = BASE_SPEED + speedDifference;
	int LeftSpeed = BASE_SPEED - speedDifference;

	RightSpeed = max(RightSpeed, MIN_SPEED);
	RightSpeed = min(RightSpeed, MAX_SPEED);
	LeftSpeed = max(LeftSpeed, MIN_SPEED);
	LeftSpeed = min(LeftSpeed, MAX_SPEED);

	motors.setSpeeds(LeftSpeed, RightSpeed);
}

// ,  go_ .. step  
void go_step()
{
	old_wall_mode = -1;
	stop_step = millis() + step_time; //     
	get_distance();
	start_back_dist = back_distance;
	while (millis() < stop_step && forward_distance>95)
	{
		set_pid();
		delay(5);
	}
	motors.setSpeeds(0, 0);
	delay(50);

	if (forward_distance<200) //      
	{
		if (forward_distance>105)
		{
			forw_go();
		}
	}
	else //     ,    
	{
		//      if (start_back_dist < 200)
		//       back_go(310);
		//       else
		//        if (start_back_dist < 500)
		//         back_go(720);
	}

	motors.setSpeeds(0, 0);
	delay(100);
	if (!localized)
	{
		getPoint();
		setcell(currentPoint.x, currentPoint.y);
	}
	step_count++;
}

//   wall_mode: 0 -  , 1 - , 2 - , 3 - 
void getwallmode()
{
	old_wall_mode = wall_mode;//   ,    -    error  lasterror
	byte new_wall_mode = 0;
	if (left_distance < wallexist && right_distance < wallexist) new_wall_mode = 3;// 
	if (right_distance < wallexist && left_distance > wallexist) new_wall_mode = 2;// 
	if (right_distance > wallexist && left_distance < wallexist) new_wall_mode = 1;// 
	if (right_distance > wallexist && left_distance > wallexist) new_wall_mode = 0;// 

	if (old_wall_mode == -1) old_wall_mode = new_wall_mode;//       
	if (new_wall_mode != old_wall_mode) //  ,    ,     
	{
		motors.setSpeeds(BASE_SPEED, BASE_SPEED);
		delay(100);
		if (left_distance < wallexist && right_distance < wallexist) new_wall_mode = 3;// 
		if (right_distance < wallexist && left_distance > wallexist) new_wall_mode = 2;// 
		if (right_distance > wallexist && left_distance < wallexist) new_wall_mode = 1;// 
		if (right_distance > wallexist && left_distance > wallexist) new_wall_mode = 0;// 
	}

	wall_mode = new_wall_mode;

	if (wall_mode != old_wall_mode)//   wall_mode  "" last_error 
	{
		switch (wall_mode)
		{
		case 3:  lasterror = left_distance - right_distance;
		case 2: lasterror = right_distance - half_cell;
		case 1: lasterror = left_distance - half_cell;
		}
	}
}

void turn_right()
{
	byte r_dist[100];//    
	byte crdist = 0;//   r_dist
	byte n_dist[100];//      
	byte c_dist = 250;
	int add_dist = 0;
	byte add = 0;
	int c_port = left_sharp_pin;
	if (forward_distance > wallexist)
		c_port = back_sharp_pin;
	long StartRotate = millis();
	while (millis() < StartRotate + turn)
	{
		motors.setSpeeds(BASE_SPEED, -BASE_SPEED);
		int sharp = analogRead(c_port);
		c_dist = min(20760 / (sharp - 11), 250);
		if (c_dist < 0) c_dist = 250;
		add_dist = add_dist + c_dist;
		add++;
		if (add == 25) //  25  -       
		{
			r_dist[crdist] = add_dist / 25;
			add_dist = 0;
			add = 0;
			crdist++;
		}
		if (crdist == 100) //      100 - ,    
			crdist = 0;
	}
	motors.setSpeeds(0, 0); //   

	//  
	r_direction = r_direction + 1;
	if (r_direction == 4) r_direction = 0;

	//     200,       ""
	if (r_dist[crdist - 1] < 200)
	{
		byte c_index = 0;
		//      0  99
		for (int i = crdist - 1; i > 0; --i)
		{
			n_dist[c_index] = r_dist[i];
			c_index++;
		}
		for (int i = 99; i > crdist + 1; --i)
		{
			n_dist[c_index] = r_dist[i];
			c_index++;
		}
		//  delay(20000);  
		// for (int i = 0; i < 100; i++)
		//  Serial.println(n_dist[i]);

		//     ,      60 ,    5  -   
		c_dist = n_dist[0];
		byte m_dist = c_dist;
		byte m_index = 0;

		for (int i = 1; i < 62; i++)
		{
			if (m_dist > n_dist[i])
			{
				m_dist = n_dist[i];
				m_index = i;
			}
		}

		if ((c_dist > m_dist + 5) || (c_port == back_sharp_pin && c_dist > m_dist + 1))
		{
			StartRotate = millis();
			long ms = StartRotate + m_index * 4 + 10;
			if (c_port == back_sharp_pin)
				ms = StartRotate + m_index * 7 + 10;
			//  
			while (millis() < ms)
			{
				motors.setSpeeds(-BASE_SPEED, BASE_SPEED);
			}
			motors.setSpeeds(0, 0);
			delay(200);
		}
	}//     200   ""
}


void turn_left()
{
	byte r_dist[100];//    
	byte crdist = 0;//   r_dist
	byte n_dist[100];//      
	byte c_dist = 250;
	int add_dist = 0;
	byte add = 0;
	int c_port = right_sharp_pin;
	if (forward_distance > wallexist)
		c_port = back_sharp_pin;

	long StartRotate = millis();
	while (millis() < StartRotate + turn)
	{
		motors.setSpeeds(-BASE_SPEED, BASE_SPEED);
		int sharp = analogRead(c_port);
		c_dist = min(20760 / (sharp - 11), 250);
		if (c_dist < 0) c_dist = 250;
		add_dist = add_dist + c_dist;
		add++;
		if (add == 25) //  25  -       
		{
			r_dist[crdist] = add_dist / 25;
			add_dist = 0;
			add = 0;
			crdist++;
		}
		if (crdist == 100) //      100 - ,    
			crdist = 0;
	}
	motors.setSpeeds(0, 0); //   

	//  
	r_direction = r_direction - 1;
	if (r_direction == -1) r_direction = 3;

	//     200,       ""
	if (r_dist[crdist - 1] < 200)
	{
		byte c_index = 0;
		//      0  99
		for (int i = crdist - 1; i > 0; --i)
		{
			n_dist[c_index] = r_dist[i];
			c_index++;
		}
		for (int i = 99; i > crdist + 1; --i)
		{
			n_dist[c_index] = r_dist[i];
			c_index++;
		}


		//     ,      60 ,    5  -   
		c_dist = n_dist[0];
		byte m_dist = c_dist;
		byte m_index = 0;

		for (int i = 1; i < 62; i++)
		{
			if (m_dist > n_dist[i])
			{
				m_dist = n_dist[i];
				m_index = i;
			}
		}

		if ((c_dist > m_dist + 5) || (c_port == back_sharp_pin && c_dist > m_dist + 1))
		{
			//  
			StartRotate = millis();
			long ms = StartRotate + m_index * 4 + 10;
			if (c_port == back_sharp_pin)
				ms = StartRotate + m_index * 7 + 10;
			//  
			while (millis() < ms)
			{
				motors.setSpeeds(BASE_SPEED, -BASE_SPEED);
			}
			motors.setSpeeds(0, 0);
			delay(200);
		}
	}//     200   ""
}

void turn_round()
{
	byte r_dist[100];//    
	byte crdist = 0;//   r_dist
	byte n_dist[100];//      
	byte c_dist = 250;
	byte c_distr = 250;
	byte c_distl = 250;
	int add_dist = 0;
	byte add = 0;
	long StartRotate = millis();
	while (millis() < StartRotate + turnturn)
	{
		motors.setSpeeds(-BASE_SPEED, BASE_SPEED);
		int sharp = analogRead(right_sharp_pin);
		c_dist = min(20760 / (sharp - 11), 250);
		if (c_dist < 0) c_dist = 250;
		add_dist = add_dist + c_dist;
		add++;
		if (add == 25) //  25  -       
		{
			r_dist[crdist] = add_dist / 25;
			add_dist = 0;
			add = 0;
			crdist++;
		}
		if (crdist == 100) //      100 - ,    
			crdist = 0;
	}

	r_direction = r_direction + 2;
	if (r_direction == 4) r_direction = 0;
	if (r_direction == 5) r_direction = 1;
	// r_direction= r_direction%4;
	motors.setSpeeds(0, 0);
	//      ""
	byte c_index = 0;
	//      0  99
	for (int i = crdist - 1; i > 0; --i)
	{
		n_dist[c_index] = r_dist[i];
		c_index++;
	}
	for (int i = 99; i > crdist + 1; --i)
	{
		n_dist[c_index] = r_dist[i];
		c_index++;
	}

	//     ,      60 ,    5  -   
	c_dist = n_dist[0];
	byte m_dist = c_dist;
	byte m_index = 0;

	for (int i = 1; i < 62; i++)
	{
		if (m_dist > n_dist[i])
		{
			m_dist = n_dist[i];
			m_index = i;
		}
	}

	if (c_dist > m_dist + 5)
	{
		//  
		StartRotate = millis();
		long ms = StartRotate + m_index * 4 + 10;

		//  
		while (millis() < ms)
		{
			motors.setSpeeds(BASE_SPEED, -BASE_SPEED);
		}
		motors.setSpeeds(0, 0);
		delay(200);
	}

}



//void turn_left()
//{
//  long StartRotate = millis();
//  while (millis() < StartRotate + turn)
//   motors.setSpeeds(-BASE_SPEED, BASE_SPEED);
//   
// motors.setSpeeds(0, 0);
// r_direction = r_direction -1;
// if (r_direction==-1) r_direction = 3;
// // r_direction= r_direction%4;
// Serial.println("turn_left");
// Serial.print("direction: ");
// Serial.println(r_direction);
//}


//void turn_round()
//{
//  long StartRotate = millis();
//  while (millis() < StartRotate + turnturn)
//   motors.setSpeeds(BASE_SPEED, -BASE_SPEED);
//    r_direction = r_direction + 2;
//    if (r_direction==4) r_direction = 0;
//    if (r_direction==5) r_direction = 1;
//    // r_direction= r_direction%4;
// motors.setSpeeds(0, 0);
// Serial.println("turn_round");
// Serial.print("direction: ");
// Serial.println(r_direction);
//}

void where_go()//   
{
	get_distance();

	if (right_distance>200)
	{
		turn_right();
		delay(300);
		go_step();
	}
	else
	{
		if (forward_distance>200)
		{
			go_step();
		}
		else
		{
			if (left_distance>200)
			{
				turn_left();
				delay(300);
				go_step();
			}
			else
			{
				turn_round();
				delay(300);
				go_step();

			}
		}
	}
	delay(300);
}

void forw_go()//   
{
	while (forward_distance>95)
	{
		motors.setSpeeds(120, 120);
		get_distance();
	}
	motors.setSpeeds(0, 0);
	delay(100);
}

void back_go(int dist)//   
{
	while (back_distance<dist)
	{
		motors.setSpeeds(120, 120);
		get_distance();
	}
	motors.setSpeeds(0, 0);
	delay(100);
}

//   
void setcell(int x, int y)
{
	//   
	byte walls = 0;
	if (right_distance < wallexist)
		walls = 1;
	if (forward_distance < wallexist)
		walls = walls + 2;
	if (left_distance < wallexist)
		walls = walls + 4;
	if (back_distance < wallexist)
		walls = walls + 8;

	find_lab[x][y] = walls;
}

//        (r_direction)
void getPoint()
{
	switch (r_direction)
	{
	case 0:
		currentPoint.y = currentPoint.y + 1;
		break;

	case 1:
		currentPoint.x = currentPoint.x + 1;
		break;

	case 2:
		currentPoint.y = currentPoint.y - 1;
		break;

	case 3:
		currentPoint.x = currentPoint.x - 1;
		break;

	}
}

void getnormalLab() //        511 (normallab)
{

	//  //      ()
	//  startPoint.x = startPoint.x - x0;
	//  startPoint.y = startPoint.y - y0;
	//  //      ()
	//  finishPoint.x = finishPoint.x - x0;
	//  finishPoint.y = finishPoint.y - y0;


	//   "" 
	for (byte x = 0; x<5; x++)
		for (byte y = 0; y<8; y++)
		{
			normallab[x][y].left = false;
			normallab[x][y].right = false;
			normallab[x][y].forw = false;
			normallab[x][y].back = false;
			//    normallab[x][y].x = x;
			//    normallab[x][y].y = y;
			normallab[x][y].vizited = true;
		}
	//     labirint     
	for (byte l = 0; l<40; l++)
	{
		int x = l % 5;
		int y = l / 5;
		switch (labirint[l])

		{
		case 0:
			normallab[x][y].left = !false;
			normallab[x][y].right = !false;
			normallab[x][y].forw = !false;
			normallab[x][y].back = !false;
			break;
		case 1:
			normallab[x][y].left = !false;
			normallab[x][y].right = !true;
			normallab[x][y].forw = !false;
			normallab[x][y].back = !false;
			break;
		case 2:
			normallab[x][y].left = !false;
			normallab[x][y].right = !false;
			normallab[x][y].forw = !true;
			normallab[x][y].back = !false;
			break;
		case 3:
			normallab[x][y].left = !false;
			normallab[x][y].right = !true;
			normallab[x][y].forw = !true;
			normallab[x][y].back = !false;
			break;
		case 4:
			normallab[x][y].left = !true;
			normallab[x][y].right = !false;
			normallab[x][y].forw = !false;
			normallab[x][y].back = !false;
			break;
		case 5:
			normallab[x][y].left = !true;
			normallab[x][y].right = !true;
			normallab[x][y].forw = !false;
			normallab[x][y].back = !false;
			break;
		case 6:
			normallab[x][y].left = !true;
			normallab[x][y].right = !false;
			normallab[x][y].forw = !true;
			normallab[x][y].back = !false;
			break;
		case 7:
			normallab[x][y].left = !true;
			normallab[x][y].right = !true;
			normallab[x][y].forw = !true;
			normallab[x][y].back = !false;
			break;
		case 8:
			normallab[x][y].left = !false;
			normallab[x][y].right = !false;
			normallab[x][y].forw = !false;
			normallab[x][y].back = !true;
			break;
		case 9:
			normallab[x][y].left = !false;
			normallab[x][y].right = !true;
			normallab[x][y].forw = !false;
			normallab[x][y].back = !true;
			break;
		case 10:
			normallab[x][y].left = !false;
			normallab[x][y].right = !false;
			normallab[x][y].forw = !true;
			normallab[x][y].back = !true;
			break;
		case 11:
			normallab[x][y].left = !false;
			normallab[x][y].right = !true;
			normallab[x][y].forw = !true;
			normallab[x][y].back = !true;
			break;
		case 12:
			normallab[x][y].left = !true;
			normallab[x][y].right = !false;
			normallab[x][y].forw = !false;
			normallab[x][y].back = !true;
			break;
		case 13:
			normallab[x][y].left = !true;
			normallab[x][y].right = !true;
			normallab[x][y].forw = !false;
			normallab[x][y].back = !true;
			break;
		case 14:
			normallab[x][y].left = !true;
			normallab[x][y].right = !false;
			normallab[x][y].forw = !true;
			normallab[x][y].back = !true;
			break;
		case 15:
			normallab[x][y].left = !true;
			normallab[x][y].right = !true;
			normallab[x][y].forw = !true;
			normallab[x][y].back = !true;
			break;
		}
	}
}

//  
void getMatrix()
{
	//    99 
	for (byte x = 0; x<5; x++)
		for (byte y = 0; y<8; y++)
			matrix[x][y] = 99;

	matrix[startPoint.x][startPoint.y] = 0;//      0 

	byte StepNumber = 0; //    -     
	//
	//every time we check all cells on equal value and StepNumber, if value=StepNumber we check nearly cells on availability and if true - set stepnumber on it
	int x = 0;
	int y = 0;
	bool isfinish = false;
	//   ,            (StepNumber),  ,   ,        ,    , ,        
	//   ,  ,            ,   99 -            
	while (StepNumber < 99 && !isfinish)
	{
		for (x = 0; x<5; x++)
			for (y = 0; y<8; y++)
			{
				if (matrix[x][y] == StepNumber)
				{
					//        Serial.print("x: ");
					//        Serial.print(x);
					//        Serial.print("y: ");
					//        Serial.print(y);
					//        Serial.print("matrix xy: ");
					//        Serial.println(matrix[x][y]);
					//        Serial.print("left: ");
					//        Serial.print(normallab[x][y].left);
					//        Serial.print("right: ");
					//        Serial.print(normallab[x][y].right);
					//        Serial.print("forw: ");
					//        Serial.print(normallab[x][y].forw);
					//        Serial.print("back: ");
					//        Serial.print(normallab[x][y].back);


					if (normallab[x][y].left == true) //   ,   -       .. x-1 > -1
						if (x - 1>-1 && x - 1 < 5)
							if (matrix[x - 1][y] > StepNumber + 1) //     ,    -       
							{
								matrix[x - 1][y] = StepNumber + 1;
								if (finishPoint.x == x - 1 && finishPoint.y == y) //      -  
								{
									isfinish = true;
								}
							}
					if (normallab[x][y].right == true) //   ,   -       .. x+1 < 5
						if (x + 1>-1 && x + 1 < 5)
							if (matrix[x + 1][y] > StepNumber + 1)//     ,    -       
							{
								matrix[x + 1][y] = StepNumber + 1;
								if (finishPoint.x == x + 1 && finishPoint.y == y) //      -  
								{
									isfinish = true;
								}
							}
					if (normallab[x][y].forw == true)  //   ,   -       .. y+1 < 11
					{
						if (y + 1>-1 && y + 1 < 11)
						{
							if (matrix[x][y + 1] > StepNumber + 1) //     ,    -       
							{
								matrix[x][y + 1] = StepNumber + 1;
								if (finishPoint.x == x && finishPoint.y == y + 1) //      -  
								{
									isfinish = true;
								}
							}
						}
					}
					if (normallab[x][y].back == true) //   ,   -       .. y-1 > -1
						if (y - 1>-1 && y - 1 < 11)
							if (matrix[x][y - 1] > StepNumber + 1)//     ,    -       
							{
								matrix[x][y - 1] = StepNumber + 1;
								if (finishPoint.x == x && finishPoint.y == y - 1) //      -  
								{
									isfinish = true;
								}
							}

				}
			}
		StepNumber++;
	}

	//  // 
	//    for (byte x=0; x<5; x++)
	//    {
	//      for (byte y=0; y<8; y++)
	//       {
	//        Serial.print(matrix[x][y]);
	//        Serial.print(" | ");
	//       }
	//       Serial.println();
	//    }
}

void startinit()
{
	startPoint.x = 5;
	startPoint.y = 11;


	r_direction = 0;
	get_distance();
}

//    
void GetDirCompass()
{
	r_direction = 0;
}

//      x, y
byte GetLabPiont(byte x, byte y)
{
	return labirint[y * 5 + x];
}

int Check_find_count()
{
	byte res = 0;
	TPoint cpoint;

	bool sovpadenie = false;
	for (int x = 0; x < 5; x++)
		for (int y = 0; y < 8; y++)
		{
			if (GetLabPiont(x, y) == find_lab[2][2])//       
			{
				sovpadenie = true;//     x,y  
				//        
				for (byte f_x = 0; f_x < 5; f_x++)
					for (byte f_y = 0; f_y < 5; f_y++)
					{
						if (find_lab[f_x][f_y] < 99) //     
						{
							byte offset_x = f_x - 2;//     x  y
							byte offset_y = f_y - 2;
							if (x + offset_x < 0 || x + offset_x > 4 || y + offset_y < 0 || y + offset_y > 7) //        -        
							{
								sovpadenie = false;
							}
							else
							{
								if (find_lab[f_x][f_y] != GetLabPiont(x + offset_x, y + offset_y))//         
									sovpadenie = false;
							}
						}
					}
			}
			//  ,           1
			if (sovpadenie)
			{
				res++;
				byte offset_x = currentPoint.x - 2;
				byte offset_y = currentPoint.y - 2;
				startPoint.x = x + offset_x;
				startPoint.y = y + offset_y;
			}
		}
	return res;
}

void get_location()
{
	//     
	currentPoint.x = 2;
	currentPoint.y = 2;

	//   
	for (byte i = 0; i<5; i++)
		for (byte j = 0; j<5; j++)
			find_lab[i][j] = 99;
	//     55              
	GetDirCompass();
	byte find_count = 0;// .   ,     
	setcell(currentPoint.x, currentPoint.y);
	while (find_count != 1)
	{
		find_count = Check_find_count();
		if (find_count != 1)//    1 -    
		{
			where_go();
			setcell(currentPoint.x, currentPoint.y);
		}


	}

}


void FillShortPath()
{
	//    
	for (int i = 0; i<40; i++)
	{
		shortpath[i].x = 255;
		shortpath[i].y = 255;
	}

	currentPoint.x = finishPoint.x;
	currentPoint.y = finishPoint.y;

	int Step = matrix[finishPoint.x][finishPoint.y];
	shortstepscount = Step;
	shortpath[Step].x = currentPoint.x;
	shortpath[Step].y = currentPoint.y;

	Serial.print("shortstepscount: ");
	Serial.println(shortstepscount);


	bool stepready = false;
	// Serial.println("before while");
	while (Step > -1)
	{
		stepready = false;
		if (currentPoint.x > 0)
			if (matrix[currentPoint.x - 1][currentPoint.y] == Step - 1)
				if (normallab[currentPoint.x][currentPoint.y].left)
				{
					shortpath[Step - 1].x = currentPoint.x - 1;
					shortpath[Step - 1].y = currentPoint.y;
					currentPoint.x = currentPoint.x - 1;
					stepready = true;
				}
		if (currentPoint.x < 4 && !stepready)
			if (matrix[currentPoint.x + 1][currentPoint.y] == Step - 1)
				if (normallab[currentPoint.x][currentPoint.y].right)
				{
					shortpath[Step - 1].x = currentPoint.x + 1;
					shortpath[Step - 1].y = currentPoint.y;
					currentPoint.x = currentPoint.x + 1;
					stepready = true;
				}
		if (currentPoint.y > 0 && !stepready)
			if (matrix[currentPoint.x][currentPoint.y - 1] == Step - 1)
				if (normallab[currentPoint.x][currentPoint.y].back)
				{
					shortpath[Step - 1].x = currentPoint.x;
					shortpath[Step - 1].y = currentPoint.y - 1;
					currentPoint.y = currentPoint.y - 1;
					stepready = true;
				}
		if (currentPoint.y < 10 && !stepready)
			if (matrix[currentPoint.x][currentPoint.y + 1] == Step - 1)
				if (normallab[currentPoint.x][currentPoint.y].forw)
				{
					shortpath[Step - 1].x = currentPoint.x;
					shortpath[Step - 1].y = currentPoint.y + 1;
					currentPoint.y = currentPoint.y + 1;
					stepready = true;
				}
		Step = Step - 1;
		//  Serial.println(Step);
	}

	//  for (int i = 0; i < shortstepscount; i++ )
	//  {
	//    Serial.print(shortpath[i].x); 
	//    Serial.print(", "); 
	//    Serial.println(shortpath[i].y); 
	//   }
}

byte getDirection(TPoint CPoint, TPoint NextPoint)
{
	if (CPoint.x > NextPoint.x) return 3;
	if (CPoint.x < NextPoint.x) return 1;
	if (CPoint.y < NextPoint.y) return 0;
	if (CPoint.y > NextPoint.y) return 2;
}

//        
void ShortBack()
{
	//  backway = true;//on back way don't setcell

	for (int i = shortstepscount; i>0; --i) //in last iterration we calc direction to last cell (i-1)
	{
		short newDirection = getDirection(shortpath[i], shortpath[i - 1]);

		switch (newDirection)
		{
		case 0:
			if (r_direction == 1)
				turn_left();
			else
				if (r_direction == 2)
					turn_round();
				else
					if (r_direction == 3)
						turn_right();
			break;

		case 1:
			if (r_direction == 0)
				turn_right();
			else
				if (r_direction == 2)
					turn_left();
				else
					if (r_direction == 3)
						turn_round();
			break;

		case 2:
			if (r_direction == 0)
				turn_round();
			else
				if (r_direction == 1)
					turn_right();
				else
					if (r_direction == 3)
						turn_left();
			break;

		case 3:
			if (r_direction == 0)
				turn_left();
			else
				if (r_direction == 1)
					turn_round();
				else
					if (r_direction == 2)
						turn_right();
			break;
		}
		delay(300);
		go_step();
		delay(300);
	}
}

//        
void ShortForward()
{
	//  backway = true;//on back way don't setcell

	for (int i = 0; i<shortstepscount; i++)
	{
		short newDirection = getDirection(shortpath[i], shortpath[i + 1]);

		switch (newDirection)
		{
		case 0:
			if (r_direction == 1)
				turn_left();
			else
				if (r_direction == 2)
					turn_round();
				else
					if (r_direction == 3)
						turn_right();
			break;

		case 1:
			if (r_direction == 0)
				turn_right();
			else
				if (r_direction == 2)
					turn_left();
				else
					if (r_direction == 3)
						turn_round();
			break;

		case 2:
			if (r_direction == 0)
				turn_round();
			else
				if (r_direction == 1)
					turn_right();
				else
					if (r_direction == 3)
						turn_left();
			break;

		case 3:
			if (r_direction == 0)
				turn_left();
			else
				if (r_direction == 1)
					turn_round();
				else
					if (r_direction == 2)
						turn_right();
			break;
		}
		delay(300);
		go_step();
		delay(300);
	}
}

void ShortGo(byte startx, byte starty, byte finishx, byte finishy)
{
	startPoint.x = startx;
	startPoint.y = starty;
	currentPoint.x = startx;
	currentPoint.y = starty;
	finishPoint.x = finishx;
	finishPoint.y = finishy;
	getnormalLab();
	//shownlab();
	getMatrix();
	// ShowMatrix();
	FillShortPath();
	currentPoint.x = startx;
	currentPoint.y = starty;
	ShortForward();

}

void shownlab()
{
	byte val;
	for (int x = 0; x < 5; x++)
	{
		for (int y = 0; y < 8; y++)
		{
			val = 0;
			if (normallab[x][y].left) val = val + 4;
			if (normallab[x][y].forw) val = val + 2;
			if (normallab[x][y].right) val = val + 1;
			if (normallab[x][y].back) val = val + 8;
			Serial.print(val);
			Serial.print(" | ");

		}
		Serial.println();
	}
}

void ShowMatrix()
{
	// 
	for (byte x = 0; x<5; x++)
	{
		for (byte y = 0; y<8; y++)
		{
			Serial.print(matrix[x][y]);
			Serial.print(" | ");
		}
		Serial.println();
	}
}
void writeshortpath()
{
	byte i = 1;
	byte k = 0;
	EEPROM.write(0, shortstepscount);
	while (k<(shortstepscount + 1) * 2 + 1)
	{
		EEPROM.write(i, shortpath[k].x);
		i++;
		EEPROM.write(i, shortpath[k].y);
		i++;
		k++;
	}
}

//   int   2-    p_adress  p_adress+1
void EEPROMWriteInt(int p_address, int p_value)
{
	byte lowByte = ((p_value >> 0) & 0xFF);
	byte highByte = ((p_value >> 8) & 0xFF);

	EEPROM.write(p_address, lowByte);
	EEPROM.write(p_address + 1, highByte);
}

//     int  2-  
unsigned int EEPROMReadInt(int p_address)
{
	byte lowByte = EEPROM.read(p_address);
	byte highByte = EEPROM.read(p_address + 1);
	int res = ((lowByte << 0) & 0xFF) + ((highByte << 8) & 0xFF00);
	if (res > 32768) res = res - 65535;
	return res;

}

